diff --git a/src/login/logind.h b/src/login/logind.h
index 8645e8572..35308e8d1 100644
--- a/src/login/logind.h
+++ b/src/login/logind.h
@@ -163,7 +163,7 @@ int manager_send_changed(Manager *manager, const char *property, ...) _sentinel_
 int manager_dispatch_delayed(Manager *manager);
 
 /* gperf lookup function */
-const struct ConfigPerfItem* logind_gperf_lookup(const char *key, unsigned length);
+const struct ConfigPerfItem* logind_gperf_lookup(const char *key, size_t length);
 
 int manager_watch_busname(Manager *manager, const char *name);
 void manager_drop_busname(Manager *manager, const char *name);
diff --git a/src/shared/af-list.c b/src/shared/af-list.c
index f396115a3..5948de281 100644
--- a/src/shared/af-list.c
+++ b/src/shared/af-list.c
@@ -25,7 +25,7 @@
 #include "util.h"
 #include "af-list.h"
 
-static const struct af_name* lookup_af(register const char *str, register unsigned int len);
+static const struct af_name* lookup_af(register const char *str, register size_t len);
 
 #include "af-to-name.h"
 #include "af-from-name.h"
diff --git a/src/shared/arphrd-list.c b/src/shared/arphrd-list.c
index 284043cd9..2cb0793ce 100644
--- a/src/shared/arphrd-list.c
+++ b/src/shared/arphrd-list.c
@@ -25,7 +25,7 @@
 #include "util.h"
 #include "arphrd-list.h"
 
-static const struct arphrd_name* lookup_arphrd(register const char *str, register unsigned int len);
+static const struct arphrd_name* lookup_arphrd(register const char *str, register size_t len);
 
 #include "arphrd-to-name.h"
 #include "arphrd-from-name.h"
diff --git a/src/shared/cap-list.c b/src/shared/cap-list.c
index bd5bffbfa..18ad86a19 100644
--- a/src/shared/cap-list.c
+++ b/src/shared/cap-list.c
@@ -25,7 +25,7 @@
 #include "cap-list.h"
 #include "missing.h"
 
-static const struct capability_name* lookup_capability(register const char *str, register unsigned int len);
+static const struct capability_name* lookup_capability(register const char *str, register size_t len);
 
 #include "cap-to-name.h"
 #include "cap-from-name.h"
diff --git a/src/shared/errno-list.c b/src/shared/errno-list.c
index 34d133148..9796c1d2f 100644
--- a/src/shared/errno-list.c
+++ b/src/shared/errno-list.c
@@ -25,7 +25,7 @@
 #include "errno-list.h"
 
 static const struct errno_name* lookup_errno(register const char *str,
-                                                 register unsigned int len);
+                                                 register size_t len);
 
 #include "errno-to-name.h"
 #include "errno-from-name.h"
